#include <stdlib.h>
#include "screen.h"
#include "poly.h"
#include "sincos.h"

/*
   sin_tbl,cos_tbl ̊px̒Pʂ 2/512
   x 65536{
 */
void draw_poly( struct Camera *view, struct Poly *poly, struct Object *obj,
		struct VRAM_PIX *col )
{
int i ;
int wsz, wcz, wsy, wcy, wsx, wcx ;
int af, bf, cf ;
int wx, wy, wz ;
int x2d[3],y2d[3] ;

 wsz = sin_tbl[obj->oz % 512] ;
 wcz = cos_tbl[obj->oz % 512] ;
 wsy = sin_tbl[obj->oy % 512] ;
 wcy = cos_tbl[obj->oy % 512] ;
 wsx = sin_tbl[obj->ox % 512] ;
 wcx = cos_tbl[obj->ox % 512] ;
 // printf("%d,%d,%d\n",obj->ox,obj->oy,obj->oz) ;
 for( i=0 ; i<3 ; i++ ){
   //   printf("i1=%d poly.x=%8d poly.y=%8d poly.z=%8d\n",
   //	  i,poly->x[i],poly->y[i],poly->z[i]) ;
   af =  poly->x[i]*wcz - poly->y[i]*wsz ;
   bf =  poly->x[i]*wsz + poly->y[i]*wcz ;
   cf =  poly->z[i] ;
   wx = af/65536 ;
   wy = bf/65536 ;
   wz = cf ;
   //   printf("i2=%d poly.x=%8d poly.y=%8d poly.z=%8d\n",
   //	  i,wx,wy,wz) ;

   af =  wx*wcy + wz*wsy ;
   bf =  wy ;
   cf = -wx*wsy + wz*wcy ;
   wx = af/65536 ;
   wy = bf ;
   wz = cf/65536 ;
   //   printf("i3=%d poly.x=%8d poly.y=%8d poly.z=%8d\n",
   //	  i,wx,wy,wz) ;

   af = wx ;
   bf = wy*wcx - wz*wsx ;
   cf = wy*wsx + wz*wcx ;
   wx = af ;
   wy = bf/65536 ;
   wz = cf/65536 ;
   //   if( i==0 ){
   //     printf("i=%d poly.x=%8d poly.y=%8d poly.z=%8d\n",
   //       i,wx,wy,wz) ;
     //   }
   x2d[i] = wx*( 1+((wz)*150)/65536 )+160 ;
   y2d[i] = wy*( 1+((wz)*150)/65536 )+100 ;
   //   if( i==0 ){
   //     printf("i=%d poly.x=%08x poly.y=%08x poly.z=%08x\n",
   //       i,x2d[i],y2d[i],0) ;
   //   }
 }
 
 // put_line( 0,0,320,200,&col2 ) ;
 // put_line( 320,0,0,200,&col2 ) ;
 put_line( x2d[0],y2d[0],x2d[1],y2d[1],col ) ;
 put_line( x2d[1],y2d[1],x2d[2],y2d[2],col ) ;
 put_line( x2d[2],y2d[2],x2d[0],y2d[0],col ) ;
}
